-- MultiGasket.ex
--	A graphical representation of the Chaos Game resulting
-- 	in Sierpinski's Gasket. Added games for numbers of
--	starting points from 1 to 9.

--	Type a number from 1 to 9 to select the number of selection points for the game.
--	Use the up and down arrows to increase/decrease the fractional distance to the next point by .1
--	ESC to exit

include get.e
include graphics.e

atom 	gr_mode, key,
	arc_x, arc_y, divisor, poly
sequence point, next_point
gr_mode = graphics_mode(18)

procedure play_game()
	puts(1, "Distance divided by ") ? divisor
	while key = -1 do
		pixel(rand(15), next_point)
		next_point -= (next_point-point[rand(poly)])/divisor
		key = get_key()
	end while
end procedure

procedure setup()
	point = {}
	next_point = {}
	clear_screen()
	ellipse(1, 0, {120,40}, {520,440})
	for i = 1 to poly do
		arc_x = 320 + 200 * sin(((360/poly)*i-180)/57.4)
		arc_y = 240 + 200 * cos(((360/poly)*i-180)/57.4)
		point = append(point, {arc_x, arc_y})
		pixel(15, point[i])
	end for
	next_point = append(next_point, rand(640))
	next_point = append(next_point, rand(480))
	puts(1, "Starting coordinates ") ? next_point
	puts(1, "Sides of polygon ") ? poly
	key = get_key()
end procedure

poly = 3
divisor = 2
key = get_key()
while key != 27 do
	setup()
	play_game()
	if key = 328 then divisor += .1
	elsif key = 336 then divisor -= .1
	elsif key>48 and key<58 then poly = key-48 divisor = 2
	end if
end while
gr_mode = graphics_mode(-1)